unit LicenceFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CSheriff;

type
  TLicenceForm = class(TForm)
    Label1: TLabel;
    editReference: TEdit;
    Label2: TLabel;
    editLicence: TEdit;
    btnOK: TButton;
    btnCancel: TButton;
    procedure btnOKClick(Sender: TObject);
  private
    { Private declarations }
    m_Sheriff:TSheriff;
    m_bLicenceOK:boolean;
  public
    { Public declarations }
    procedure SetSheriff(Sheriff:TSheriff);
    function  IsLicenceOK:boolean;
  end;

var
  LicenceForm: TLicenceForm;

implementation

{$R *.DFM}

function TLicenceForm.IsLicenceOK:boolean;
begin
    IsLicenceOK:=m_bLicenceOK;
end;

procedure TLicenceForm.SetSheriff(Sheriff:TSheriff);
var
    strReference:string;
begin
    m_Sheriff:=Sheriff;
    m_Sheriff.GetReference(strReference);
    editReference.Text:=strReference;
    editLicence.Text:='';
    m_bLicenceOK:=false;
end;

procedure TLicenceForm.btnOKClick(Sender: TObject);
var	strError:string;
begin
    if(editLicence.Text='') then
    begin
	    MessageBox(HWND(NIL),'Please enter your licence key','Error',MB_OK or MB_ICONSTOP);
        exit;
    end;
    if(m_Sheriff.SetLicence(PChar(editReference.Text),PChar(editLicence.Text))=false) then
    begin
	    m_Sheriff.GetLastErrorMessage(strError);
    	MessageBox(HWND(NIL),PChar(strError),'Sheriff Error',MB_OK or MB_ICONSTOP);
        exit;
    end;
   	MessageBox(HWND(NIL),'Licence has been successfully registered','SlsDemo',MB_OK);
    Close;
    m_bLicenceOK:=true;
end;

end.
