unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, SlsApi, CSheriff, ToolWin, ComCtrls;

type
  TFormMain = class(TForm)
    MainMenu1: TMainMenu;
    App: TMenuItem;
    Open: TMenuItem;
    Close1: TMenuItem;
    Edit1: TMenuItem;
    View1: TMenuItem;
    Help1: TMenuItem;
    Index1: TMenuItem;
    About1: TMenuItem;
    Timer1: TTimer;
    procedure About1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    m_Sheriff:TSheriff;
    m_bRunInFullMode:boolean;
    m_dwAccessLevel:DWORD;
  public
    { Public declarations }
    procedure SetSheriff(Sheriff:TSheriff);
    procedure SetRunMode(bFullMode:boolean);
    procedure SetAccessLevel(dwLevel:DWORD);
  end;

var
  FormMain: TFormMain;

implementation

uses About;

{$R *.DFM}

procedure TFormMain.SetRunMode(bFullMode:boolean);
begin
    m_bRunInFullMode:=bFullMode;
end;

procedure TFormMain.SetAccessLevel(dwLevel:DWORD);
begin
    m_dwAccessLevel:=dwLevel;
end;

procedure TFormMain.SetSheriff(Sheriff:TSheriff);
begin
    m_Sheriff:=Sheriff;
end;

procedure TFormMain.About1Click(Sender: TObject);
begin
    ShowAboutBox;
end;

procedure TFormMain.Timer1Timer(Sender: TObject);
var
    vUpdate:SLS_UPDATE;
    vPermit:SLS_PERMIT;
begin
    if(m_bRunInFullMode=true) then
    begin
        vUpdate.UnitsReserved:=0;
        vUpdate.UnitsConsumed:=0;
        vPermit.UnitsGranted:=0;
        vPermit.AccessKey:=0;
        m_Sheriff.Update(vUpdate,vPermit);
    end;    
end;

end.

