// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__9FE45CD8_230F_11D1_A3B6_000000000000__INCLUDED_)
#define AFX_MAINFRM_H__9FE45CD8_230F_11D1_A3B6_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CMainFrame : public CFrameWnd
{
protected: // create from serialization only
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
	UINT	m_nUpdateTimerID;

// Operations
public:
	CMainFrame();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnUpdateFeatureFeaturelevel1(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFeatureFeaturelevel2(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFeatureFeaturelevel3(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFeatureFeaturelevel4(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFeatureFeaturelevel5(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__9FE45CD8_230F_11D1_A3B6_000000000000__INCLUDED_)
